/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomNodeFilter_H__
#define __GdomNodeFilter_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomNodeFilter GdomNodeFilter;
typedef struct _GdomNodeFilterClass GdomNodeFilterClass;


#define GDOM_TYPE_NODE_FILTER            (gdom_node_filter_get_type())
#define GDOM_NODE_FILTER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_NODE_FILTER, GdomNodeFilter))
#define GDOM_NODE_FILTER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_NODE_FILTER, GdomNodeFilter)Class)
#define GDOM_IS_NODE_FILTER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_NODE_FILTER))
#define GDOM_IS_NODE_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_NODE_FILTER))
#define GDOM_NODE_FILTER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_NODE_FILTER, GdomNodeFilterClass))

typedef struct _GdomNodeFilterPrivate GdomNodeFilterPrivate;

struct _GdomNodeFilter {
    GdomDOMObject parent_instance;
    GdomNodeFilterPrivate *priv;
};

struct _GdomNodeFilterClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_node_filter_get_type (void);


/* XXX TODO: custom function gdom_node_filter_accept_node */

G_END_DECLS

#endif /* __GdomNodeFilter_H__ */
